#!/usr/bin/python3
import sys
from traceback import print_exc
import time
# import python dbus module
import dbus
# import python dbus GLib mainloop support
import dbus.mainloop.glib
#from PySide2.QtCore import *
# from PySide2.QtCore import QCoreApplication, Signal, Slot
from gi.repository import Gio
import os

def inputting_method():
    ret = iface.Get("org.fcitx.Fcitx.InputMethod", "IMList")
    inputList = ["sogouimebs"]
    newInput = []
    for line in ret:
        if line[3] != False and line[1] not in inputList:       # not sogou input method, and true
            change = list(line)
            change[3] = dbus.Boolean(False)
            newInput.append(dbus.Struct(change))                
            continue
        if line[1] in inputList:
            if line[3] != True:                                 # sogou input method, and false
                change = list(line)
                change[3] = dbus.Boolean(True)
                newInput.append(dbus.Struct(change))            
                continue
            else:                                               # sogou input method, and true
                newInput.append(line)
                continue
        newInput.append(line)                                   # not  sogou input method, and false
    newInputList = dbus.Array(newInput) 
    iface.Set("org.fcitx.Fcitx.InputMethod", "IMList", newInputList)

if __name__ == '__main__':
    # Enable glib main loop support
    dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)
    #time.sleep(5)
    bus = dbus.SessionBus()
    try:
        # Get the remote object
        proxy = bus.get_object('org.fcitx.Fcitx', '/inputmethod')
        # Get the remote interface for the remote object
        iface = dbus.Interface(proxy, dbus_interface='org.freedesktop.DBus.Properties')
    except dbus.DBusException:
        print_exc()
        sys.exit(1)
    # Start the application
    #app = QCoreApplication(sys.argv)
    inputting_method()
    #if (os.path.exists("/tmp/sogou.log")):
        #print("not exists")
    #else:
        #inputting_method()
        #open("/tmp/sogou.log","w")
		

    # enter in the main loop
    #app.exec_()
